module EmojiEncoder
  extend ActiveSupport::Concern

    def attrs_for_emoji(*attrs)
      emoji_attributes_methods(attrs)
      save_attrs_to_var(attrs)
    end

    def save_attrs_to_var(attrs)
      attrs.each do |attr|
        before_save "encode_#{attr}".to_sym
      end
    end

    def emoji_attributes_methods(attrs)
      attrs.each do |attr|
        define_method "decode_#{attr.to_s}" do
          CGI.unescape(self.try(attr.to_sym).to_s)
        end

        define_method "encode_#{attr.to_s}" do
          if self.try(attr.to_sym) != nil
            encoded_text = CGI.escape(self.try(attr.to_sym).to_s)
            self.send("#{attr.to_s}=", encoded_text)
          end
        end
      end
    end

end
